
.AUTOIMPORT +			; so we don't have to import every symbol

.SEGMENT "HEADER"
	.INCLUDE "nrom.inc"
.SEGMENT "VECTORS"
	.ADDR 0000h,0000h,0000h,NMI,Reset,0000h
	
.INCLUDE "vars.inc"

.SEGMENT "OAMBUF"
oambuf:	.res $100

.DATA
Palette:
 .INCBIN "fontpal.dat"
 
 
.SEGMENT "CHR"
.INCBIN "font.chr"

.CODE

Sub_BCDDigits:
		LDY #0
		; set carry to subtract low nybble of first loop
		; following loops may or may not have carry set
		SEC
		bcs @FirstLoop
	@SubLoop:
		plp
	@FirstLoop:
		LDA (xp1),Y
		PHA	
		AND #$0F
		STA tr
		
		lda (xp0),Y
		PHA
		AND #$0F
		sbc tr
		CMP #$A	
		BCC @skiplocarry
		sec	
		sbc #6	
	@skiplocarry:
		STA tr
		PLA
		AND #$F0
		clc
		ADC tr
		
		tax
		PLA
		AND #$F0
		STA tr
		txa
		sec
		SBC tr
		bcc @dohiborrow
		beq @resetcarry
		CMP #$A0
		BCC @resetcarry
	@dohiborrow:
		sec
		SBC #$60
	@skiphicarry2:
		clc
		PHP
		BCC @skipresetcarry
	@resetcarry:
		SEC
		PHP
	@skipresetcarry:
		STA (xp2),Y	
		INY
		CPY #BCDDIGITS
		BNE @SubLoop
		PLP	
		
		RTS

Add_BCDDigits:
		LDY #0
		CLC
		BCC @FirstLoop
	@AddLoop:
		PLP			
	@FirstLoop:
		LDA (xp1),Y		
		PHA			
		AND #$0F		
		STA tr		
		
		lda (xp0),Y		
		PHA		
		AND #$0F		
		ADC tr		
		CMP #$A			
		BCC @skiplocarry	
		clc			
		adc #6			
	@skiplocarry:
		STA tr		
		PLA			
		AND #$F0		
		CLC			
		ADC tr		
		
		STA tr		
		PLA			
		AND #$F0			

		CLC			
		ADC tr
		bcs @dohicarry2
		CMP #$A0		
		BCC @skiphicarry2	
	@dohicarry2:
		CLC			
		ADC #$60		
		SEC				
	@skiphicarry2:
		PHP
		STA (xp2),Y	
			
		INY		
		CPY #BCDDIGITS	
		BNE @AddLoop		
		PLP
		RTS		
		